apiVersion: batch/v1
kind: Job
metadata:
  name: {{ job_name }}
  namespace: {{ namespace }}
spec:
  backoffLimit: {{ job_backoff_limit | default(3) }}
  completions: {{ job_completions | default(1) }}
  parallelism: {{ job_parallelism | default(1) }}
  template:
    metadata:
      labels:
        name: "{{ job_assume_pod_netpol | default(job_name) }}"
    spec:
      automountServiceAccountToken: false
      containers:
      - args:
        - -c
        - >
{{ (job_args | default('echo no args defined')) | indent(width=10, first=True) }}
        command: [ '/bin/sh' ]
{% if (job_env | default([])) | length > 0 %}
        env:
{% for envvar in job_env %}
        - name: "{{ envvar.name | default('dummy') }}"
{% if envvar.secret_name is defined and envvar.secret_key is defined %}
          valueFrom:
            secretKeyRef:
              key: "{{ envvar.secret_key }}"
              name: "{{ envvar.secret_name }}"
{% else %}
          value: "{{ envvar.value | default('dummy') }}"
{% endif %}
{% endfor %}
{% endif %}
{% if job_image | default(False) %}
        image: {{ job_image }}
{% else %}
        image: {{ (opsimages | json_query("[?name=='busybox'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: job
{% if job_memory_limit | default(False) or job_cpu_limit | default(False) or job_cpu_request | default(False) or job_memory_request | default(False) %}
        resources:
{% if job_memory_limit | default(False) or job_cpu_limit | default(False) %}
          limits:
{% if job_cpu_limit | default(False) %}
            cpu: "{{ job_cpu_limit }}"
{% endif %}
{% if job_memory_limit | default(False) %}
            memory: "{{ job_memory_limit }}"
{% endif %}
{% endif %}
{% if job_cpu_request | default(False) or job_memory_request | default(False) %}
          requests:
{% if job_cpu_request | default(False) %}
            cpu: "{{ job_cpu_request }}"
{% endif %}
{% if job_memory_request | default(False) %}
            memory: "{{ job_memory_request }}"
{% endif %}
{% endif %}
{% endif %}
{% if (job_volumes | default([])) | length > 0 %}
        volumeMounts:
{% for volume in job_volumes %}
        - mountPath: "{{ volume.path | default('/tmp/' ~ (volume.name | default('dummy'))) }}"
          name: {{ volume.name | default('dummy') | lower | regex_replace('[\\.-_ ]', '') }}
{% endfor %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
      restartPolicy: Never
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-jobs
{% endif %}
{% if job_serviceaccount | default(False) %}
      serviceAccountName: {{ job_serviceaccount }}
{% endif %}
{% if job_run_as_uid | default(False) or job_run_privileged | default(False) or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if job_run_privileged | default(False) %}
        privileged: true
{% elif job_run_as_uid | default(False) %}
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
        runAsUser: {{ job_run_as_uid }}
{% elif rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% endif %}
{% if job_allow_unschedulable | default(True) %}
      tolerations:
      - operator: Exists
{% else %}
      tolerations: {}
{% endif %}
{% if (job_volumes | default([])) | length > 0 %}
      volumes:
{% for volume in job_volumes %}
      - name: {{ volume.name | default('dummy') | lower | regex_replace('[\\.-_ ]', '') }}
{% if (volume.kind | default('emptyDir')) == 'PersistentVolumeClaim' %}
        persistentVolumeClaim:
          claimName: {{ volume.name | default('dummy') }}
{% elif (volume.kind | default('emptyDir')) == 'ConfigMap' %}
        configMap:
          name: {{ volume.name | default('dummy') }}
{% elif (volume.kind | default('emptyDir')) == 'Secret' %}
        secret:
          secretName: {{ volume.name | default('dummy') }}
{% else %}
        emptyDir: {}
{% endif %}
{% endfor %}
{% endif %}
